//Test app; 2009 qrleon

/*
TODO

better handling of the glyph list, the playfield size, etc, etc

*/

#include <stdlib.h>
#include <time.h>
#include <curses.h>

/* Reminder: in PDCurses functions, Y goes before X! */
#define VIEW_Y 20
#define VIEW_X 70

// for use with app_mode integer
#define PLAYING 0
#define EDITING 1


// Many keys do not appear to have constants defined, so I added some here...
// this breaks portability?
#define KEYB_ESCAPE 27
#define KEYB_TAB 9
#define KEYB_SPACEBAR 32
#define KEYB_ENTER 13

#define KEYB_INSERT 331
#define KEYB_DELETE 330

#define KEYB_ARROW_LEFT 260
#define KEYB_ARROW_RIGHT 261
#define KEYB_ARROW_UP 259
#define KEYB_ARROW_DOWN 258
#define KEYB_HOME 262
#define KEYB_END 358
#define KEYB_PAGEUP 339
#define KEYB_PAGEDOWN 338

#define KEYB_CTRL_ARROW_LEFT 443
#define KEYB_CTRL_ARROW_RIGHT 444
#define KEYB_CTRL_ARROW_UP 480
#define KEYB_CTRL_ARROW_DOWN 481
#define KEYB_CTRL_HOME 447
#define KEYB_CTRL_END 448
#define KEYB_CTRL_PAGEUP 445
#define KEYB_CTRL_PAGEDOWN 446


#define KEYB_CTRL_NP_1 508
#define KEYB_CTRL_NP_2 509
#define KEYB_CTRL_NP_3 510
#define KEYB_CTRL_NP_4 511
//no need for ctrl+5
#define KEYB_CTRL_NP_6 513
#define KEYB_CTRL_NP_7 514
#define KEYB_CTRL_NP_8 515
#define KEYB_CTRL_NP_9 516


//conversation stuff
#define MSG_JOEY 5
#define MSG_JOEY_LEN 6
#define MSG_NOT_CLOSE_ENOUGH 2
#define MSG_GET_OFF_ME 3
#define MSG_COUGH 4

int i = 0;

chtype map[ VIEW_Y ][ VIEW_X ];

int quit;

//whether we're moving around as an '@' character, or editing the screen with the cursor.
int app_mode;

//holds input from getch()...
int keyb_in;

//remembers which conversation message to show
int a_message = 0;

//points to current glyph target to plot...
int current_glyph = 0;
//the glyph list
#define GLYPH_LIST_SIZE 3
chtype glyph_list[ GLYPH_LIST_SIZE ];

//our glyphs...
chtype player, ground, tree, rock, ch_joey;

//player vars
int y = 0, x = 0;
int py = VIEW_Y / 2, px = VIEW_X / 2;

int pmovy = 0, pmovx = 0;

int do_smoke = 0;
int do_talk = 0;

//Old Joey vars
int jy = 0, jx = 0;
int jmovy = 0, jmovx = 0;

//editing mode vars
int fastmove = 0, fastmove_rate = 5;

int do_plot = 0;
int do_fill = 0;
int do_grab = 0;
int do_movejoey = 0;

int paintmode = 0;


//declarations...move these to header file, i guess
void init();
void newlev();
void draw();
void input();
void move_player();
void move_joey();
void talk();
void plot_char();
void keep_glyph_selector_in_bounds();
void flood_fill();
void glyph_grabbing();
int save_board();
int load_board();
void logic();
void play();



void init()
{
    srand(time(NULL));

    keypad(initscr(),1);
    start_color();

    raw();
    nodelay(stdscr,0);
    noecho();
    curs_set(1);
    nonl();

    //set color_pairs

    #define C_BLUE 1
    #define C_GREEN 2
    #define C_CYAN 3
    #define C_RED 4
    #define C_MAGENTA 5
    #define C_YELLOW 6
    #define C_WHITE 7

    init_pair( 1, COLOR_BLUE, COLOR_BLACK );
    init_pair( 2, COLOR_GREEN, COLOR_BLACK );
    init_pair( 3, COLOR_CYAN, COLOR_BLACK );
    init_pair( 4, COLOR_RED, COLOR_BLACK );
    init_pair( 5, COLOR_MAGENTA, COLOR_BLACK );
    init_pair( 6, COLOR_YELLOW, COLOR_BLACK );
    init_pair( 7, COLOR_WHITE, COLOR_BLACK );


    //set glyphs
    player = '@' | COLOR_PAIR( C_WHITE ) | A_BOLD;
    ground = '.' | COLOR_PAIR( C_YELLOW );
    tree = 't' | COLOR_PAIR( C_GREEN ) | A_BOLD;
    rock = '*' | COLOR_PAIR( C_WHITE );
    ch_joey = 'J' | COLOR_PAIR( C_CYAN );


    //init glyph editing list

    glyph_list[ 0 ] = ground;
    glyph_list[ 1 ] = tree;
    glyph_list[ 2 ] = rock;


}

void reset_board()
{
    py = VIEW_Y / 2;
    px = VIEW_X / 2;

    jy = 12;
    jx = 12;

    for( y = 0; y < VIEW_Y; y++ )
    {
        for( x = 0; x < VIEW_X; x++ )
        {
            map[ y ][ x ] = ground;
        }
    }

    //Border the edges with rocks
    for( y = 0; y < VIEW_Y; y++ )
    {
        for( x = 0; x < VIEW_X; x++ )
        {
            if( y == 0 )          { map[ y ][ x ] = rock; }
            if( y == VIEW_Y - 1 ) { map[ y ][ x ] = rock; }
            if( x == 0 )          { map[ y ][ x ] = rock; }
            if( x == VIEW_X - 1 ) { map[ y ][ x ] = rock; }
        }
    }
}

void draw()
{
    erase();
//draw board
    for( y = 0; y < VIEW_Y; y++ )
    {
        for( x = 0; x < VIEW_X; x++ )
        {
            mvaddch( y, x, map[ y ][ x ] );
        }
    }

    if( a_message == 0 )
    {
//if there is no message to display, draw HUD
        mvprintw( 20, 0, "(L)OAD, (S)AVE" );
        mvprintw( 22, 0, "Keys: (Q)uit, (R)eset, NumLocked Numpad to move, (/) mode" );
        if( app_mode == PLAYING )
        {
            mvprintw( 23, 0, "(C) smoke a cigarette, (T)alk" );
        }
        else
        {
            mvprintw( 23, 0, "(pP)ick, (ins) grab, (space) draw, (tab) paint:    , (F)ill, (CTRL) fastmove" );
            if( paintmode == 1 )
            {
                mvprintw( 23, 48, "ON" );
            }
            else
            {
                mvprintw( 23, 48, "OFF" );
            }
            mvprintw( 24, 0, "(J) reposition Old Joey" );

            mvprintw( 11, 73, ".t*" );
            mvprintw( 10, 73 + current_glyph, "V" );
        }
        mvprintw( 0, 70, "kc %d", keyb_in );
// got a message? print it
    }
    switch( a_message )
    {
        case 1: {
            mvprintw( 23, 0, "(dud message)" );
            break;
        }
        case 2: {
            mvprintw( 23, 0, "Old Joey's hard of hearing. Try getting closer." );
            break;
        }
        case 3: {
            mvprintw( 23, 0, "Old Joey: \"Get off me, you big dope!\"" );
            break;
        }
        case 4: {
            mvprintw( 23, 0, "Old Joey: \"COUGH COUGH HACK WHEEZE COUGH\"" );
            break;
        }
        case 5: {
            mvprintw( 23, 0, "Old Joey: \"Blar barllalrhl hgghghffffffffffffffff'p.\"" );
            break;
        }
        case 6: {
            mvprintw( 23, 0, "Old Joey: \"Bring dingalingaling. Pop doppadododo.\"" );
            break;
        }
        case 7: {
            mvprintw( 23, 0, "Old Joey: \"ObloblobloblobloblobloblbolboKenLobbobblboblboblo\"" );
            break;
        }
        case 8: {
            mvprintw( 23, 0, "Old Joey: \"...\"" );
            break;
        }
        case 9: {
            mvprintw( 23, 0, "Old Joey: \"Pretty girl with big boob\"" );
            break;
        }
        case 10: {
            mvprintw( 23, 0, "Old Joey: \"Dander dander dander dander dander dander dander.\"" );
            break;
        }
    }
//and clear a_message var
    a_message = 0;

//draw Old Joey
    mvaddch( jy, jx, ch_joey );

//draw player or editing cursor
//previously, it was curs_set( app_mode );, but this is more explicit...
    switch( app_mode )
    {
        case PLAYING:
        {
            curs_set( 0 );
            break;
        }
        case EDITING:
        {
            curs_set( 1 );
            break;
        }
    }
    if( app_mode == PLAYING )
    {
        mvaddch( py, px, player );
    }
    if( app_mode == EDITING )
    {
        move( py, px );
    }

    //smoking...
    if( do_smoke == 1 )
    {
        if( app_mode == PLAYING )
        {
            mvaddch( py, px + 1, '-' );
            if( ( jy == py ) && ( jx == px + 1 ) ) { a_message = 4; }

            int smoke_y = py;
            //draw the smoke
            //also, check if old joey is colliding with any of the smoke.
            while( smoke_y >= 0 )
            {
                mvaddch( smoke_y, px + 2, '/' );
                if( ( jy == smoke_y ) && ( jx == px + 2 ) ) { a_message = 4; }
                smoke_y--;
                mvaddch( smoke_y, px + 3, '|' );
                if( ( jy == smoke_y ) && ( jx == px + 3 ) ) { a_message = 4; }
                smoke_y--;
                mvaddch( smoke_y, px + 2, '\\' );
                if( ( jy == smoke_y ) && ( jx == px + 2 ) ) { a_message = 4; }
                smoke_y--;
                mvaddch( smoke_y, px + 1, '|' );
                if( ( jy == smoke_y ) && ( jx == px + 1 ) ) { a_message = 4; }
                smoke_y--;
            }
        }
        do_smoke = 0;
    }
}

void input()
{
    keyb_in = getch();
    switch( keyb_in )
    {
    //wants to quit
        case 'q':
        case 'Q':
        case KEYB_ESCAPE:
            quit = 1;
            break;

    //reset the board
        case 'r':
        case 'R':
            reset_board();
            break;

    //move around
        case '4':
        case KEYB_ARROW_LEFT:
            pmovx = -1;
            break;
        case '6':
        case KEYB_ARROW_RIGHT:
            pmovx = 1;
            break;
        case '8':
        case KEYB_ARROW_UP:
            pmovy = -1;
            break;
        case '2':
        case KEYB_ARROW_DOWN:
            pmovy = 1;
            break;

    //MOVE DIAGONALLY!
        case '7':
        case KEYB_HOME:
        {
            pmovy = -1;
            pmovx = -1;
        }
            break;
        case '9':
        case KEYB_PAGEUP:
        {
            pmovy = -1;
            pmovx = 1;
        }
            break;
        case '1':
        case KEYB_END:
        {
            pmovy = 1;
            pmovx = -1;
        }
            break;
        case '3':
        case KEYB_PAGEDOWN:
        {
            pmovy = 1;
            pmovx = 1;
        }
            break;

    //fastmove using alt+key
        case KEYB_CTRL_NP_1:
        case KEYB_CTRL_END:
        {
            fastmove = 1;
            pmovy = 1;
            pmovx = -1;
        }
            break;
        case KEYB_CTRL_NP_2:
        case KEYB_CTRL_ARROW_DOWN:
        {
            fastmove = 1;
            pmovy = 1;
        }
            break;
        case KEYB_CTRL_NP_3:
        case KEYB_CTRL_PAGEDOWN:
        {
            fastmove = 1;
            pmovy = 1;
            pmovx = 1;
        }
            break;
        case KEYB_CTRL_NP_4:
        case KEYB_CTRL_ARROW_LEFT:
        {
            fastmove = 1;
            pmovx = -1;
        }
            break;
        case KEYB_CTRL_NP_6:
        case KEYB_CTRL_ARROW_RIGHT:
        {
            fastmove = 1;
            pmovx = 1;
        }
            break;
        case KEYB_CTRL_NP_7:
        case KEYB_CTRL_HOME:
        {
            fastmove = 1;
            pmovy = -1;
            pmovx = -1;
        }
            break;
        case KEYB_CTRL_NP_8:
        case KEYB_CTRL_ARROW_UP:
        {
            fastmove = 1;
            pmovy = -1;
        }
            break;
        case KEYB_CTRL_NP_9:
        case KEYB_CTRL_PAGEUP:
        {
            fastmove = 1;
            pmovy = -1;
            pmovx = 1;
        }
            break;

    //switching app modes
        case '/':
        {
            //maybe this should be moved to a function...
            //was originally appmode = 1 - appmode, but that allows only for two states.
            if( app_mode == PLAYING )
            {
                app_mode = EDITING;
            }
            else if( app_mode == EDITING )
            {
                app_mode = PLAYING;
            }
            //deactivate paintmode if switching!
            paintmode = 0;

            //standing on Joey easter egg
            if( ( py == jy ) && ( px == jx ) )
            {
                a_message = MSG_GET_OFF_ME;
            }
        }
            break;

    //plotting stuff
        case KEYB_SPACEBAR:
        {
            do_plot = 1;
        }
            break;
    //wants to delete something
        case KEYB_DELETE:
        {
            do_plot = 2;
        }
            break;
    //wants to flood-fill
        case 'F':
        case 'f':
        {
            do_fill = 1;
        }
            break;
    //wants to grab a glyph type
        case KEYB_INSERT:
        case KEYB_ENTER:
        {
            do_grab = 1;
        }
            break;
    //cycle forward through element list
        case 'p':
        if( app_mode == EDITING )
        {
            current_glyph++;
        }
            break;
    //cycle backwards
        case 'P':
        if( app_mode == EDITING )
        {
            current_glyph--;
        }
            break;
    //wants to toggle continuous draw mode
        case KEYB_TAB:
        if( app_mode == EDITING )
        {
            paintmode = 1 - paintmode;
        }
            break;
    //wants to smoke a cigarette
        case 'C':
        case 'c':
        {
            do_smoke = 1;
        }
            break;
    //want to talk to Old Joey.
        case 'T':
        case 't':
        {
            do_talk = 1;
        }
            break;
    //wants to move Old Joey. (while editing)
        case 'J':
        case 'j':
        {
            do_movejoey = 1;
        }
            break;

    //wants to save a screen...
        case 'S':
        case 's':
        {
            save_board();
        }
            break;
    //wants to load a screen...
        case 'L':
        case 'l':
        {
            load_board();
        }
    }
}

void move_player()
{
    int mv_i = 1;
    if( fastmove == 1 && app_mode == EDITING )
    {
        mv_i = fastmove_rate;
    }
    while( mv_i > 0 )
    {
        //ugh, messy.
        if( ( ( map[ py + pmovy ][ px + pmovx ] == ground ) && ( ( py + pmovy != jy ) || ( px + pmovx != jx ) ) ) || app_mode == EDITING )
        {
            if( ( py + pmovy >= 0 ) && ( py + pmovy < VIEW_Y ) && ( px + pmovx >= 0 ) && ( px + pmovx < VIEW_X ) )
            {
                py += pmovy;
                px += pmovx;
            }
        }
        plot_char();
        mv_i--;
    }
    pmovy = 0;
    pmovx = 0;
    fastmove = 0;
}

void move_joey()
{
    if( app_mode == EDITING )
    {
        if( do_movejoey == 1 )
        {
            jy = py;
            jx = px;
        }
    }
    do_movejoey = 0;

    if( app_mode == PLAYING )
    {
        int jmdir = 0;
        if( rand() % 6 == 0 )
        {
            jmdir = 1 + ( rand() % 4 );
            switch( jmdir )
            {
                case 1: jmovy = -1; break;
                case 2: jmovy = 1; break;
                case 3: jmovx = -1; break;
                case 4: jmovx = 1; break;
            }
            jmdir = 0;

            //prevent old joey from wandering off the edge of the screen
            if( ( jy + jmovy < 0 ) || ( jy + jmovy > VIEW_Y ) )
            {
                jmovy = 0;
            }
            if( ( jx + jmovx < 0 ) || ( jx + jmovx > VIEW_X ) )
            {
                jmovx = 0;
            }
        }

        if( ( map[ jy + jmovy ][ jx + jmovx ] == ground ) && ( ( jy + jmovy != py ) || ( jx + jmovx != px ) ) )
        {
            jy += jmovy;
            jx += jmovx;
        }
        jmovy = 0;
        jmovx = 0;
    }
}

void talk()
{
    do_talk = 0;
    if( app_mode == EDITING )
    {
        return;
    }
    if( ( py > jy - 2 ) && ( py < jy + 2 ) && ( px > jx -2 ) && ( px < jx + 2 ) )
    {
        a_message = MSG_JOEY + rand() % MSG_JOEY_LEN;
    }
    else
    {
        a_message = MSG_NOT_CLOSE_ENOUGH;
    }
}

void plot_char()
{
    if( app_mode == EDITING )
    {
        if( do_plot == 1 ||  paintmode == 1 )
        {
            map[ py ][ px ] = glyph_list [ current_glyph ];
        }
        if( do_plot == 2 )
        {
            map[ py ][ px ] = ground;
        }
        //flood fill...
        if( do_fill == 1 )
        {
            flood_fill();
        }
    }
    do_plot = 0;
    do_fill = 0;
}

void keep_glyph_selector_in_bounds()
{
    if( current_glyph < 0 )
    {
        current_glyph = GLYPH_LIST_SIZE - 1;
    }
    if( current_glyph > GLYPH_LIST_SIZE - 1 )
    {
        current_glyph = 0;
    }
}

void flood_fill()
{
    //glyph type to fill over
    chtype target_glyph = map[ py ][ px ];

    //don't bother if the target type and fill type are identical.
    if( target_glyph == glyph_list[ current_glyph ] )
    {
        return;
    }
    int floodmap[ VIEW_Y ][ VIEW_X ];
    int fi_y = 0, fi_x = 0;
    int loopcheck = 0;

    //init floodmap array
    for( fi_y = 0; fi_y < VIEW_Y; fi_y++ )
    {
        for( fi_x = 0; fi_x < VIEW_X; fi_x++ )
        {
            floodmap[ fi_y ][ fi_x ] = 0;
        }
    }
    //mark start point
    floodmap[ py ][ px ] = 1;

    //search floodmap for marked coordinates
    while( loopcheck == 0 )
    {
        for( fi_y = 0; fi_y < VIEW_Y; fi_y++ )
        {
            for( fi_x = 0; fi_x < VIEW_X; fi_x++ )
            {
                if( floodmap[ fi_y ][ fi_x ] == 1 )
                {
                    if( map[ fi_y ][ fi_x ] == target_glyph )
                    {
                        map[ fi_y ][ fi_x ] = glyph_list[ current_glyph ];
                        //mark coordinates adjacent to current position.
                    //durr keeping array indices from going out of bounds...
                        if( fi_y > 0 )
                        {
                            if( floodmap[ fi_y - 1 ][ fi_x ] == 0 )
                            {
                                floodmap[ fi_y - 1 ][ fi_x ] = 1;
                            }
                        }
                        if( fi_y < VIEW_Y - 1 )
                        {
                            if( floodmap[ fi_y + 1 ][ fi_x ] == 0 )
                            {
                                floodmap[ fi_y + 1 ][ fi_x ] = 1;
                            }
                        }
                        if( fi_x > 0 )
                        {
                            if( floodmap[ fi_y ][ fi_x - 1 ] == 0 )
                            {
                                floodmap[ fi_y ][ fi_x - 1 ] = 1;
                            }
                        }
                        if( fi_x < VIEW_X - 1 )
                        {
                            if( floodmap[ fi_y ][ fi_x + 1 ] == 0 )
                            {
                                floodmap[ fi_y ][ fi_x + 1 ] = 1;
                            }
                        }
                    }
                    //tick off the coordinate.
                    floodmap[ fi_y ][ fi_x ] = 2;
                }
            }
        }
        //loop exit. if floodmap has any 1's, stay in loop.
        loopcheck = 1;
        for( fi_y = 0; fi_y < VIEW_Y; fi_y++ )
        {
            for( fi_x = 0; fi_x < VIEW_X; fi_x++ )
            {
                if( floodmap[ fi_y ][ fi_x ] == 1 )
                {
                    loopcheck = 0;
                }
            }
        }
    }
}

void glyph_grabbing()
{
    //glyph grabbing
    if( app_mode == EDITING )
    {
        if( do_grab == 1 )
        {
            chtype target_glyph = map[ py ][ px ];
            current_glyph = 0;
            int iter;
            for( iter = 0; iter < GLYPH_LIST_SIZE; iter++ )
            {
                if( glyph_list[ current_glyph ] != target_glyph )
                {
                    current_glyph++;
                }
            }
        }
    }
    do_grab = 0;
}

int save_board()
{
    FILE *fp;

    fp = fopen( "test.txt", "w" );
    if( fp == NULL )
    {
        return 1;
    }
    int yy = 0, xx = 0;
    //first five values store xy positions of Player and Joey, and app_mode...
    fputc( app_mode, fp );
    fputc( py, fp );
    fputc( px, fp );
    fputc( jy, fp );
    fputc( jx, fp );

    //then, store the board data.
    for( yy = 0; yy < VIEW_Y; yy++ )
    {
        for( xx = 0; xx < VIEW_X; xx++ )
        {
            if( map[ yy ][ xx ] == ground )
            {
                fputc( 1, fp );
            }
            if( map[ yy ][ xx ] == tree )
            {
                fputc( 2, fp );
            }
            if( map[ yy ][ xx ] == rock )
            {
                fputc( 3, fp );
            }
        }
    }
    fclose( fp );
    return 0;
}
int load_board()
{
    FILE *fp;

    fp = fopen( "test.txt", "r" );
    if( fp == NULL )
    {
        return 1;
    }
    int in = 0, yy = 0, xx = 0;
    //first 5 values store xy positions of Player and Joey, and app_mode...
    app_mode = fgetc( fp );
    py = fgetc( fp );
    px = fgetc( fp );
    jy = fgetc( fp );
    jx = fgetc( fp );

    //then, load the board data.
    for( yy = 0; yy < VIEW_Y; yy++ )
    {
        for( xx = 0; xx < VIEW_X; xx++ )
        {
            in = fgetc( fp );
            if( in == 1 )
            {
                map[ yy ][ xx ] = ground;
            }
            if( in == 2 )
            {
                map[ yy ][ xx ] = tree;
            }

            if( in == 3 )
            {
                map[ yy ][ xx ] = rock;
            }
        }
    }
    fclose( fp );
    return 0;
}

void logic()
{
    glyph_grabbing();

    if( do_talk == 1 )
        {
            talk();
        }

    keep_glyph_selector_in_bounds();
    move_player();
    move_joey();
    //i put plot_char() inside move_player()...
}

void play()
{
    logic();
    draw();
    input();
}

int main()
{
    quit = 0;

    app_mode = PLAYING;

    init();
    mvprintw( 0, 0, "Just a test. Press a key..." );
    getch();

    reset_board();

    while( quit == 0 )
    {
        play();
    }

    //exit PDCurses
    exit( endwin() );

    return 0;
}
